/*****************************************************************/
/*                                                               */
/*          Copyright (c) 1991-1992 by J.Nisimoto                */
/*                                                               */
/*                   H  c  a  d  3  D  - Ver 2.0                 */
/*                                                               */
/*  Permission to use,copy,modify,and distribute this software.  */
/*                                                               */
/*  send.c: Connect any C program to Hcad3D.                     */
/*                                                               */
/*                                                               */
/*****************************************************************/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/X.h>
#include <X11/Xatom.h>
#include <string.h>

char atom_name[ ] = {"_HYPERCAD"};

char *send(data)
 char *data;
{
  Display *mydisplay;
  Window  rootwin;
  Atom atom,ret_atom;
  int i,ret_format,done;
  unsigned long ret_len,ret_after;
  char *ret_prop;
  XEvent ev;
  

  mydisplay = XOpenDisplay("");
  if(!mydisplay){
    return("NG");
  }
  rootwin   = DefaultRootWindow(mydisplay);
  atom = XInternAtom(mydisplay,atom_name,True);
  XSelectInput(mydisplay,rootwin,PropertyChangeMask);
    if(atom != None){
      XChangeProperty(mydisplay,rootwin,atom,XA_STRING,16,PropModeReplace,data,
                  strlen(data));
      done = 0;
      while(done==0){
        if(XEventsQueued(mydisplay,QueuedAfterReading)==0){
          XFlush(mydisplay);
        }
        XNextEvent(mydisplay,&ev);
        if(ev.type==PropertyNotify){
          XGetWindowProperty(mydisplay,rootwin,atom,0,8192,False,XA_STRING,
                      &ret_atom,&ret_format,&ret_len,&ret_after,&ret_prop);
          if((ret_prop[0]=='O')||(ret_prop[0] == 'N')){
            done=1;
            return(ret_prop);
          }
          XFree(ret_prop);
	}
      }
    }
}


/***********************************************
 main()
{                                                                 
    char s[30];                                                     
    sprintf(s,"p 0 0.0 0.0 3.0");                                     
    printf("ret %s \n",send(s));     
    sprintf(s,"p 0 0.0 2.82843 -1.0");                                     
    printf("ret %s \n",send(s));     
    sprintf(s,"p 0 -2.448490 -1.41421 -1.0");
    printf("ret %s \n",send(s));     
    sprintf(s,"p 0 2.44949 -1.41421 -1.0");                        
    printf("ret %s \n",send(s));     
    getchar();               
    sprintf(s,"d 0");                                               
    printf("ret %s \n",send(s));                                
    getchar();               
    sprintf(s,"c");                                                 
    printf("ret %s \n",send(s));                                 
}                                                                 

*******************************************************/

